<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Kay Strobach <info@kay-strobach.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */


$LANG->includeLLFile('EXT:plupload/mod1/locallang.xml');
require_once(PATH_t3lib . 'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]



/**
 * Module 'Upload Files' for the 'plupload' extension.
 *
 * @author	Kay Strobach <info@kay-strobach.de>
 * @package	TYPO3
 * @subpackage	tx_plupload
 */
class  tx_plupload_module1 extends t3lib_SCbase {
				var $pageinfo;

				/**
				 * Initializes the Module
				 * @return	void
				 */
				function init()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

					parent::init();

					/*
					if (t3lib_div::_GP('clear_all_cache'))	{
						$this->include_once[] = PATH_t3lib.'class.t3lib_tcemain.php';
					}
					*/
				}

				/**
				 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
				 *
				 * @return	void
				 */
				function menuConfig()	{
					global $LANG;
				}

				/**
				 * Main function of the module. Write the content to $this->content
				 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
				 *
				 * @return	[type]		...
				 */
				function main()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

					// Access check!
					// The page will show only if there is a valid page and if this page may be viewed by the user
					$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
					$access = is_array($this->pageinfo) ? 1 : 0;
				
						// initialize doc
					$this->doc = t3lib_div::makeInstance('template');
					$this->doc->setModuleTemplate(t3lib_extMgm::extPath('plupload') . 'mod1/mod_template.html');
					$this->doc->backPath = $BACK_PATH;
					$this->doc->getPageRenderer()->loadExtJS();
					$docHeaderButtons = $this->getButtons();

					if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))	{

							// Draw the form
						$this->doc->form = '<form action="" method="post" enctype="multipart/form-data">';
							// Render content:
						$this->moduleContent();
					} else {
							// If no access or if ID == zero
						$docHeaderButtons['save'] = '';
						$this->content.=$this->doc->spacer(10);
					}
					$this->doc->getPageRenderer()->addInlineLanguageLabelFile(
						t3lib_extMgm::extPath('plupload') . 'mod1/locallang.xml'
					);
					$this->doc->getPageRenderer()->addJsFile(
						t3lib_extMgm::extRelPath('plupload') . 'mod1/main.js'
					);
					$this->doc->getPageRenderer()->addCssFile(
						t3lib_extMgm::extRelPath('plupload') . 'mod1/main.css'
					);
					$this->doc->getPageRenderer()->addInlineSettingArray(
						'plupload',
						array(
							'pluploadpath' => t3lib_extMgm::extRelPath('plupload').'mod1/plupload',
							'getid'        => urlencode(t3lib_div::_GET('id')),
							'be_typo_user' => urlencode($_COOKIE['be_typo_user']),
						)
					);
					
					// compile document
					#$markers['CONTENT']       = $this->content;
					$markers['CONTENT']       = '';
					//Path to plupload
					$markers['PLUPLOADPATH']  = t3lib_extMgm::extRelPath('plupload').'mod1/plupload';
					//path were to upload the file
					$markers['GETID']         = urlencode(t3lib_div::_GET('id'));
					//PHPSSID
					$markers['be_typo_user']  = urlencode($_COOKIE['be_typo_user']);
					//Language markers:
					$markers['LANG.SELECTFILES']  = $LANG->getLL('SELECTFILES');
					$markers['LANG.STARTUPLOAD']  = $LANG->getLL('STARTUPLOAD');
					$markers['LANG.DROPFILE']     = $LANG->getLL('DROPFILE');
					$markers['LANG.UPLOADFILES']  = $LANG->getLL('UPLOADFILES');
					$markers['LANG.FILEQUEUE']    = $LANG->getLL('FILEQUEUE');
					// Build the <body> for the module
					$this->content = $this->doc->startPage($LANG->getLL('title'));
					$this->content.= $this->doc->moduleBody($this->pageinfo, $docHeaderButtons, $markers);
					$this->content.= $this->doc->endPage();
					$this->content = $this->doc->insertStylesAndJS($this->content);
				
				}

				/**
				 * Prints out the module HTML
				 *
				 * @return	void
				 */
				function printContent()	{

					$this->content.=$this->doc->endPage();
					echo $this->content;
				}

				/**
				 * Generates the module content
				 *
				 * @return	void
				 */
				function moduleContent()	{
					$content= 'GET:'.t3lib_div::view_array($_GET).'<br />'.
						'POST:'.t3lib_div::view_array($_POST).'<br />'.
						'SESSION:'.t3lib_div::view_array($_COOKIE).'<br />'.
						'';
					$this->content.=$this->doc->section('Message #1:',$content,0,1);
				}
				

				/**
				 * Create the panel of buttons for submitting the form or otherwise perform operations.
				 *
				 * @return	array	all available buttons as an assoc. array
				 */
				protected function getButtons()	{

					$buttons = array(
						'csh' => '',
						'shortcut' => '',
						'save' => ''
					);
						// CSH
					$buttons['csh'] = t3lib_BEfunc::cshItem('_MOD_web_func', '', $GLOBALS['BACK_PATH']);

						// SAVE button
					#$buttons['save'] = '<input type="image" class="c-inputButton" name="submit" value="Update"' . t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/savedok.gif', '') . ' title="' . $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:rm.saveDoc', 1) . '" />';


						// Shortcut
					if ($GLOBALS['BE_USER']->mayMakeShortcut())	{
						$buttons['shortcut'] = $this->doc->makeShortcutIcon('', 'function', $this->MCONF['name']);
					}

					return $buttons;
				}
				
		}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/plupload/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/plupload/mod1/index.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_plupload_module1');
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>
