<?php
/**
 * based on upload.php
 *
 * Copyright 2009, Moxiecode Systems AB
 * Released under GPL License.
 *
 * License: http://www.plupload.com/license
 * Contributing: http://www.plupload.com/contributing
 */

	// HTTP headers for no cache etc
	header('Content-type: text/plain; charset=UTF-8');
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");


/**
 * Init TYPO3 and check the rights for the upload ...
 * (c) 2009 Kay Strobach   
 */ 
	ini_set('display_errors',1);
	unset($MCONF);
	define('TYPO3_MOD_PATH', '../typo3conf/ext/plupload/mod1/');
	$BACK_PATH = '../../../../typo3/';
	require ('conf.php');
	require ($BACK_PATH . 'init.php');
	require ($BACK_PATH .'template.php');
/**
 * Init FileFunctionsObject ...
 * Check Access and Permissions 
 * (c) 2009 Kay Strobach   
 */ 
	$basicFF = t3lib_div::makeInstance('t3lib_basicFileFunctions');
	$basicFF->init($FILEMOUNTS,$TYPO3_CONF_VARS['BE']['fileExtensions']);
	//check directory
	$id     = $basicFF->is_directory(t3lib_div::_GET('id')); 
	$access = $basicFF->checkPathAgainstMounts($id.'/'); 
	if(!$access) {
		die('{"jsonrpc" : "2.0", "error" : {"code": 105, "message": "You´re not allowed to access this path."}, "id" : "id"}');
	}
	//check filetype
	$fileExt = explode('.',t3lib_div::_GET('name'));
	$fileExt = $fileExt[(count($fileExt)-1)];	
	if($GLOBALS['TYPO3_CONF_VARS']['BE']['fileExtensions']['webspace']['deny']) {
		$deny = explode(',',$GLOBALS['TYPO3_CONF_VARS']['BE']['fileExtensions']['webspace']['deny']);
		if(in_array($fileExt,$deny)) {
			die('{"jsonrpc" : "2.0", "error" : {"code": 105, "message": "You´re not allowed to upload this filetype."}, "id" : "id"}');
		}
	}
	if($GLOBALS['TYPO3_CONF_VARS']['BE']['fileExtensions']['webspace']['allow']) {
		$allow = explode(',',$GLOBALS['TYPO3_CONF_VARS']['BE']['fileExtensions']['webspace']['allow']);
		if(!in_array($fileExt,$allow)) {
			die('{"jsonrpc" : "2.0", "error" : {"code": 105, "message": "You´re not allowed to upload this filetype."}, "id" : "id"}');
		}
	}
/**
 * Setup upload dir
 */ 
	$targetDir = $id;
/**
 * upload.php
 */ 
	// Settings
	$cleanupTargetDir = false; // Remove old files
	$maxFileAge = 60 * 60; // Temp file age in seconds

	// 5 minutes execution time
	@set_time_limit(5 * 60);
	// usleep(5000);

	// Get parameters
	$chunk = isset($_REQUEST["chunk"]) ? $_REQUEST["chunk"] : 0;
	$chunks = isset($_REQUEST["chunks"]) ? $_REQUEST["chunks"] : 0;
	$fileName = isset($_REQUEST["name"]) ? $_REQUEST["name"] : '';

	// Clean the fileName for security reasons
	$fileName = preg_replace('/[^\w\._]+/', '', $fileName);

	// Create target dir
	if (!file_exists($targetDir))
		@mkdir($targetDir);

	// Remove old temp files
	if (is_dir($targetDir) && ($dir = opendir($targetDir))) {
		while (($file = readdir($dir)) !== false) {
			$filePath = $targetDir . DIRECTORY_SEPARATOR . $file;

			// Remove temp files if they are older than the max age
			if (preg_match('/\\.tmp$/', $file) && (filemtime($filePath) < time() - $maxFileAge))
				@unlink($filePath);
		}

		closedir($dir);
	} else
		die('{"jsonrpc" : "2.0", "error" : {"code": 100, "message": "Failed to open temp directory."}, "id" : "id"}');

	if (strpos($_SERVER["HTTP_CONTENT_TYPE"], "multipart") !== false) {
		if (isset($_FILES['file']['tmp_name']) && is_uploaded_file($_FILES['file']['tmp_name'])) {
			// Open temp file
			$out = fopen($targetDir . DIRECTORY_SEPARATOR . $fileName, $chunk == 0 ? "wb" : "ab");
			if ($out) {
				// Read binary input stream and append it to temp file
				$in = fopen($_FILES['file']['tmp_name'], "rb");

				if ($in) {
					while ($buff = fread($in, 4096))
						fwrite($out, $buff);
				} else
					die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');

				fclose($out);
				unlink($_FILES['file']['tmp_name']);
			} else
				die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
		} else
			die('{"jsonrpc" : "2.0", "error" : {"code": 103, "message": "Failed to move uploaded file."}, "id" : "id"}');
	} else {
		// Open temp file
		$out = fopen($targetDir . DIRECTORY_SEPARATOR . $fileName, $chunk == 0 ? "wb" : "ab");
		if ($out) {
			// Read binary input stream and append it to temp file
			$in = fopen("php://input", "rb");

			if ($in) {
				while ($buff = fread($in, 4096))
					fwrite($out, $buff);
			} else
				die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');

			fclose($out);
		} else
			die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
	}

	// Return JSON-RPC response
	die('{"jsonrpc" : "2.0", "result" : null, "id" : "id"}');
?>